/////////////////////////////////////////////////////////////////////////////
// Dio.h
// 720020-11891
// 
// Applied Data Systems
// 
// Description
// -----------
// This sample application demonstrates basic use of the Digital I/O (DIO)
// driver.  It can also be used to interactively control the DIO lines
// for test purposes.  The application presents the user with a menu of
// DIO operations (read, write, get and set direction and mask) to execute,
// as well as a simple bit walking test.  
// 
// Requirements
// ------------
// ADS system with the DIO driver implemented.
//  
// Usage
// -----
// Instructions:
// - Compile and run SampleDIO
// - Select from any of the DIO operations listed in the menu.
// 
// History
// -------
// 720020-11891: January 17, 2005		jcamann
// - Created.
/////////////////////////////////////////////////////////////////////////////

#ifndef _DIO_H
#define _DIO_H

BOOL GetMask(HANDLE hDioPort, DWORD *pdwMask);
BOOL SetMask(HANDLE hDioPort, DWORD dwMask);
BOOL ReadDio(HANDLE hDioPort, DWORD *pdwDio);
BOOL WriteDio(HANDLE hDioPort, DWORD dwDio);
BOOL SetDirection(HANDLE hDioPort, DWORD dwDir);
BOOL GetDirection(HANDLE hDioPort, DWORD *pdwDir);
DWORD GetUserDword(const char *szStr);

#endif // _DIO_H